{% extends "crud.html" %}


{% block sub_head %}
    {% assets
        filters="cssrewrite, cssmin",
        output="compressed/datepicker.css",
        "css/plugins/bootstrap-datepicker.min.css"
    %}
        {{ mg.async_css(ASSET_URL) }}
    {% endassets %}
    {% assets
        filters="rjsmin",
        output="compressed/datepicker.js",
        "js/plugins/bootstrap-datepicker.min.js"
    %}
        {{ mg.js(ASSET_URL) }}
    {% endassets %}
    <style>
        .gray-bg {background-color: #f5f5f5}
    </style>
{% endblock %}


{% block top_records_navigation %}
    <div class="col"></div>
{% endblock %}


{% block datatable_filters %}
    <input type="hidden" data-datatable-filter="3" />
    <div class="col-12 col-md-4">
        <div class="input-group input-daterange">
            <input type="text" class="form-control" />
            <span class="input-group-addon">to</span>
            <input type="text" class="form-control" />
        </div>
    </div>
{% endblock %}


{% block empty_spiel %}
    Generated from Delivery Receipts.
    <br />
    Raw Material inventories are derived here.
{% endblock %}


{% block read_columns %}
{# <script> #}
    {
        data: 'raw_material',
        render: function(data) {
            return data.item_code;
        }
    },
    {
        data: 'raw_material',
        render: function(data) {
            return data.description;
        }
    },
    {
        data: 'delivery_receipt',
        className: 'd-none d-sm-table-cell',
        render: function(data, type, row) {
            if (type === 'sort') {
                return data.receipt_no;
            } else {
                return '<a href="{0}" class="font-weight-bold" aria-expanded="true"> #{1}</a>'.format('{{ url_for("delivery_receipts.edit", _id="placeholder") }}'.replace('placeholder', data._id), data.receipt_no);
            }
        }
    },
    {
        data: 'date_created',
        className: 'd-none d-sm-none d-md-table-cell',
        orderable: true
    },
    {
        data: 'quantity',
        className: 'd-none d-sm-table-cell',
        render: function(data) {
            return Math.round(data * 10000) / 10000;
        }
    },
    {#
    {
        data: 'price_per_unit',
        className: 'd-none d-sm-none d-md-table-cell',
        render: function(data) {
            return Math.round(data * 100) / 100;
        }
    },
    #}
    {
        data: 'client_from',
        className: 'd-none d-sm-table-cell',
        render: function(data) {
            return data.name;
        }
    },
    {
        data: 'client_for',
        className: 'd-none d-sm-table-cell',
        render: function(data) {
            return data.name;
        }
    },
    {
        data: 'status',
        className: 'd-none d-sm-table-cell',
        render: function(data, type) {
            if (type === 'sort') {
                return data;
            } else {
                switch(data) {
                    case 0:
                    return 'Pending';
                    case 1:
                    return 'Quality Passed';
                    case 2:
                    return 'Approved';
                    case -1:
                    return 'Void';
                    default:
                    return 'N/A';
                }
            }
        }
    },
    {
        data: 'date_quality',
        sortable: false,
        render: function(data, type, row) {
            if (data === null) {
                return '<a href="javascript:;" class="btn btn-warning btn-sm btn-block" data-receiving-toggle="quality" data-quality-target="{0}"><i class="fa fa-check fa-fw"></i><span class="d-none d-sm-none d-md-inline"> Quality Pass</span></a>'.format(data);
            } else {
                return '{0} - {1} by {2}'.format(row.quality_control_no, data, row.quality_by);
            }
        }
    },
    {
        data: 'date_approved',
        sortable: false,
        render: function(data, type, row) {
            if (data === null) {
                if (row.date_quality !== null) {
                    return '<a href="javascript:;" class="btn btn-success btn-sm btn-block" data-receiving-toggle="approve" data-approve-target="{0}"><i class="fa fa-check fa-fw"></i><span class="d-none d-sm-none d-md-inline"> Approve</span></a>'.format(data);
                }
                return '';
            } else {
                return '{0} by {1}'.format(data, row.approved_by);
            }
        }
    }
{# </script> #}
{% endblock %}


{% block sub_scripts %}
{# <script> #}
    $dom.document.on('click', '[data-receiving-toggle="quality"]', function() {
        $self = $(this);
        Swal.mixin({
            confirmButtonText: 'Next &rarr;',
            showCancelButton: true,
            focusCancel: true,
            progressSteps: ['1', '2']
        }).queue([
            {
                title: 'Quality Check Passed?',
                text: 'Input QC Number',
                input: 'text',
                inputValidator: (value) => {
                    if (!value) {
                        return 'Empty QC Number';
                    } else {
                        if (value.length < 5) {
                            return 'QC Number must be longer than 5 characters';
                        }
                        return;
                    }
                }
            },
            {
                text: 'Select Location',
                input: 'select',
                inputOptions: new Promise(resolve => {
                    setTimeout(() => {
                        $.get('/api/v1/locations/all?fields=address,name').done(function(response) {
                            data = response.data.reduce((map, obj) => (map[obj._id] = obj.name, map), {});
                            resolve(merge_objects({'': '-- Please Select Location --'}, data));
                        })
                    }, 1000)
                }),
                inputValidator: (value) => {
                    if (!value) {
                        return 'Invalid Location';
                    }
                    return;
                }
            }
        ]).then((result) => {
            if (result.value) {
                index = $self.attr('data-submit-target');
                $current_tr = $self.closest('tr');
                $.post('{{ url_for(".change_status", _id="placeholder") }}'.replace('placeholder', $current_tr.attr('id')), {'status': 1, 'quality_control_no': result.value[0].toUpperCase(), 'location': result.value[1]}, function() {})
                .done(function(response) {
                    if (isDefined(response.success) && response.success) {
                        $current_td = $self.closest('td');
                        $current_td.html('{0} - {1} by {2}'.format(result.value[0].toUpperCase(), response.date_quality, response.by));
                        $current_td.next().html('<a href="javascript:;" class="btn btn-success btn-sm btn-block" data-receiving-toggle="approve" data-submit-target="{0}"><i class="fa fa-check fa-fw"></i><span class="d-none d-sm-none d-md-inline"> Approve</span></a>'.format(index))
                    }
                    else {
                        Swal.fire('Error', response.error, 'error');
                    }
                })
                .fail(function() {
                    Swal.fire('Error', 'Server Error', 'error');
                });
            }
        });
    });

    $dom.document.on('click', '[data-receiving-toggle="approve"]', function() {
        $self = $(this);
        Swal.fire({
            type: 'question',
            title: 'Approved?',
            text: 'Item will be inputted to inventory upon submission',
            showCancelButton: true,
            focusCancel: true,
            confirmButtonText: 'Yes'
        }).then((result) => {
            if (result.value) {
                index = $self.attr('data-submit-target');
                $current_tr = $self.closest('tr');
                $.post('{{ url_for(".change_status", _id="placeholder") }}'.replace('placeholder', $current_tr.attr('id')), {'status': 2}, function() {})
                .done(function(response) {
                    if (isDefined(response.success) && response.success) {
                        $current_td = $self.closest('td');
                        $current_td.html('{0} by {1}'.format(response.date_approved, response.by));
                    }
                    $dom.datatables.records.reload('approve item');
                })
                .fail(function() {
                    Swal.fire('Error', 'Server Error', 'error');
                });
            }
        });
    });
    $dom.document.find('.input-daterange').datepicker({format: 'yyyy-mm-dd'}).on('changeDate', function(e) {
        range = '';
        $.each($(this).find('input'), function(i, v) {
            range += '{0}{1}'.format($(v).val(), (i>0)?'':',');
        })
        $dom.document.find('input[type="hidden"][data-datatable-filter=3]').val(range).trigger('input');
    });
{# </script> #}
{% endblock %}
